<template>
    <div>
        <el-card class="box-card" shadow="always" :body-style="{ height: bodyHeight }" style="overflow-y: auto;">
          <div slot="header" class="clearfix">
            <span>{{ title }}</span>
            <el-button-group style="float: right;">
              <el-button size="mini" icon="el-icon-plus" round @click="submitForm">保存</el-button>
              <el-button size="mini" icon="el-icon-back" round @click="showCard">返回</el-button>
            </el-button-group>
          </div>
          <el-form ref="form" :model="form" :rules="rules" label-width="80px">
            <el-form-item label="岗位名称" prop="postName">
              <el-input v-model="form.postName" placeholder="请输入岗位名称" />
            </el-form-item>
            <el-form-item label="岗位状态" prop="status">
              <el-radio-group v-model="form.status">
                <el-radio
                  v-for="dict in statusOptions"
                  :key="dict.id"
                  :label="dict.itemText"
                >{{dict.itemValue}}</el-radio>
              </el-radio-group>
            </el-form-item>
            <el-form-item label="备注" prop="remark">
              <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
            </el-form-item>
          </el-form>
        </el-card>
    </div>
</template>

<script>
import { getPost, updatePost } from '@/api/system/post'

export default {
  name: 'PostEdit',
  props: {
    data: {
      type: Object,
      default: function() {
        return {}
      }
    }
  },
  data () {
    return {
      bodyHeight: document.body.offsetHeight - 130 + 'px',
      title: '岗位编辑',
      // 展示切换
      showOptions: {
        data: {},
        showList: true,
        showAdd: false,
        showEdit: false,
        showDetail: false
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        postName: [
          { required: true, message: "岗位名称不能为空", trigger: "blur" }
        ]
      },
      // 状态数据字典
      statusOptions: []
    }
  },
  created () {
    console.log('id:' + this.data.id)
    this.getDicts("sys_common_status").then(response => {
      if (response.success) {
        this.statusOptions = response.data
      }
    })
    this.getPost(this.data.id)
  },
  methods: {
    showCard () {
      this.$emit('showCard', this.showOptions)
    },
    /** 获取详情 */
    getPost: function(id) {
      getPost(id).then(response => {
        if (response.success) {
          this.form = response.data
        }
      })
    },
    /** 提交按钮 */
    submitForm: function() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          updatePost(this.form).then(response => {
            if (response.success) {
              this.$message.success("保存成功")
              setTimeout(() => {
                // 2秒后跳转列表页
                this.$emit('showCard', this.showOptions)
              }, 2000)
            } else {
              this.$message.error("保存失败")
            }
          })
        }
      })
    }
  }
}
</script>

<style lang="scss" scoped>

</style>
